@interface STStatementList
{
    NSArray         *variables;
    NSArray         *expressions;
    STCExpression   *retexpr;
}
- setReturnExpression:(STExpression *)expression;
- returnExpression;
- executeInContext:context
       environment:env
          receiver:receiver
{
    id retval;
    
    while( (expression = [enumerator nextObject]) )
    {
        retval = [expression executeInContext:context 
                                  environment:env
                                     receiver:receiver];
    }
    return retval;
}

@end


@interface SmalltalkExpression:NSObject
{
    NSArray *assignments;
    NSArray *cascade;
}
- (void)setAssignments:(NSArray *)assignments
{
}
- executeInContext:
       environment:
          receiver:
{
    
}
@end


@interface STMessageExpression
{
    id target;    
    id message;
}
- setTarget:(id)object;
- target;

- executeInContext:environment:receiver:
{
    NSInvocation *invocation;
    SEL           selector;
    
    selector = [environment selectorWithName:[message selectorName]
                                 forReceiver:target];
    invocation = [NSInvocation invocationWithReceiver:target
                                             selector:selector];

    ... set arguments ...
    
    [invocation invoke]
    
    retvale = [invocation ...];
    
    return retval;
}
@end

@interface STStatementBlock
{
    NSArray *statements;
}
- blockWithStatements:(NSArray *)array
{
    ASSIGN(statements, array);
}
- (void)valueInContext:context environment:env receiver:rec
{
    SmalltalkExpression *expression;
    NSEnumenrator       *enumerator;
    id                   value = nil;
    
    while( (expression = [enumerator nextObject]) )
    {
        value = [expression valueInContext:context 
                               environment:env 
                                  receiver:rec];
    } 
    
    return value;
}
@end
